import { settleStyleQueryAll } from '@/api/settleStyle'
// 结算方式
const SettleStyle = {
  template: `
        <a-select
          :id="id"
          :placeholder="placeholder"
          allowClear
          :value="defaultVal"
          :showSearch="true"
          @change="handleChange"
          :filter-option="filterOption">
          <a-select-option v-for="item in list" :key="item[defValKey]" :value="item[defValKey]">{{ item.name }}</a-select-option>
        </a-select>
    `,
  props: {
    value: {
      type: String,
      default: ''
    },
    id: {
      type: String,
      default: ''
    },
    defValKey: {
      type: String,
      default: 'settleStyleSn'
    },
    placeholder: {
      type: String,
      default: '请选择结算方式'
    }
  },
  data() {
    return {
      defaultVal: this.value||undefined,
      list: []
    };
  },
  watch: {
    value(newValue, oldValue) {
      console.log(newValue)
      this.defaultVal = newValue||undefined
    }
  },
  mounted() {
    this.getList()
  },
  methods: {
    filterOption (input, option) {
      return (
        option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0
      )
    },
    handleChange(value) {
      console.log(value)
      this.defaultVal = value;
      const row = this.list.find(item => item[this.defValKey] == value)
      this.$emit('input', value);
      this.$emit('change', this.defaultVal, row?row.name:'');
    },
    // 列表数据
    getList () {
      const _this = this
      settleStyleQueryAll().then(res => {
        if (res.status == 200) {
          _this.list = res.data || []
        } else {
          _this.list = []
        }
      })
    },
  },
};

export default SettleStyle